api/urls.py
from django.urls import path
from . import views


app_name = 'api'
urlpatterns = [
    path('todo/list/', views.ApiTodoVL.as_view(), name='list'),
    path('todo/<int:pk>/delete/', views.ApiTodoDelV.as_view(), name='delete'),
    path('todo/create/', views.ApiTodoCV.as_view(), name='create'),
]

config/urls.py
from django.contrib import admin
from django.urls import path, include

from . import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.HomeView.as_view(), name='home'),
    path('todo/', include('todo.urls')),
    path('api/', include('api.urls')),
]

todo/urls.py
from django.urls import path
from . import views


app_name = 'todo'
urlpatterns = [
    path('', views.TodoTV.as_view(), name='index'),
]

api/models.py
from django.db import models

# Create your models here.

todo/models.py
from django.db import models


class Todo(models.Model):
    name = models.CharField('NAME', max_length=32, blank=True)
    todo = models.CharField('TODO', max_length=100)

    def __str__(self):
        return self.todo

    # 리스트 생성시 name 을 입력하지 않을때 홍길동을 기본값으로 넣어줌
    def save(self, force_insert=False, force_update=False, using=None, update_fields=None):
        if not self.name:
            self.name = '익명'
        super().save()

api/views.py
import json

from django.forms import model_to_dict
from django.http import JsonResponse
from django.shortcuts import render
from django.utils.decorators import method_decorator
from django.views.decorators.csrf import ensure_csrf_cookie
from django.views.generic.edit import BaseDeleteView, BaseCreateView
from django.views.generic.list import BaseListView

from todo.models import Todo


@method_decorator(ensure_csrf_cookie, name='dispatch')
class ApiTodoVL(BaseListView):
    model = Todo
    # template_name  JsonResponse 로 보내기 때문에 필요없음

    # https://docs.djangoproject.com/en/3.1/ref/request-response/#jsonresponse-objects
    # 아래 get method 는 임시로 만든 data 이기 때문에 table 에서 가져오도록 ListView 에서 가져오도록 수정해야 한다.
    # def get(self, request, *args, **kwargs):
    #     tmpList = [
    #         {'id': 1, 'name': '도무지f', 'todo': 'django 는 vue 와 연동하여 만들기'},
    #         {'id': 2, 'name': '주니만f', 'todo': '물량으로 사람을 움직이게 할까?'},
    #         {'id': 3, 'name': '가여운f', 'todo': '약은 얼마나 먹어야 하나?'},
    #     ]
    #     # JsonResponse 로 data 를 보낼때 딕션너리가 아니기 때문에 safe 를 False 로 한다.
    #     return JsonResponse(data=tmpList, safe=False)

    # 아래 사이트에서 클래스형 ListView 에서 JsonResponse 를 보내기 위해 수정할 곳을 찾는다.
    # http://ccbv.co.uk/projects/Django/3.0/django.views.generic.list/ListView/
    def render_to_response(self, context, **response_kwargs):
        # context 변수안에 object_list 로 가져오 data 를 value 로 딕셔너리로 해체하여 list type 로 만든다.
        todoList = list(context['object_list'].values())
        return JsonResponse(data=todoList, safe=False)


# @method_decorator(csrf_exempt, name='dispatch')
class ApiTodoDelV(BaseDeleteView):
    model = Todo

    def delete(self, request, *args, **kwargs):
        self.object = self.get_object()
        self.object.delete()
        return JsonResponse(data={}, status=204)


# @method_decorator(csrf_exempt, name='dispatch')
class ApiTodoCV(BaseCreateView):
    model = Todo
    fields = '__all__'

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs['data'] = json.loads(self.request.body)
        return kwargs

    def form_valid(self, form):
        print('form_valid(): ', form)
        self.object = form.save()
        newTodo = model_to_dict(self.object)
        print(f'newTodo: {newTodo}')
        return JsonResponse(data=newTodo, status=201)

    def form_invalid(self, form):
        print('form_invalid(): ', form)
        print('form_invalid(): ', self.request.POST)
        print('form_invalid(): ', self.request.body.decode('utf8'))
        return JsonResponse(data=form.errors, status=400)

config/views.py
from django.views.generic import TemplateView


class HomeView(TemplateView):
    template_name = 'home.html'

todo/views.py
from django.contrib.admindocs.views import TemplateView
from django.shortcuts import render


class TodoTV(TemplateView):
    template_name = 'todo/todo_index.html'

templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>{% block title %}home.html{% endblock %}</title>

    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.15.1/css/all.css">
    <link rel="icon" href="{% static 'img/favicon.ico' %}">

    {% block extra-style %}{% endblock %}
</head>
<body style="padding-top: 90px">
<!--Main Menu                    fixed-top 사용하면 body 에 padding-top 을 넣어야 한다.-->
    <nav class="navbar navbar-expand-lg navbar-dark bg-primary fixed-top">
        <span class="navbar-brand mx-5 mb-0 font-weight-bold font-italic">Django & Vue</span>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item mx-1 btn btn-primary">
                    <a class="nav-link" text="white" href="{% url 'home' %}">Home</a>
                </li>
                <li class="nav-item mx-1 btn btn-primary">
                    <a class="nav-link" text="white" href="{% url 'todo:index' %}">TODO</a>
                </li>
                <li class="nav-item mx-1 btn btn-primary">
                    <a class="nav-link" text="white" href="{% url 'home' %}">EXTEND(MENU)</a>
                </li>

                <li class="nav-item dropdown mx-1 btn btn-primary">
                    <a class="nav-link dropdown-toggle"  text="white" href="#" id="dropdown">
                    Util
                    </a>
                    <div class="dropdown-menu">
                        <a class="dropdown-item" href="{% url 'admin:index' %}">Admin</a>
                        <div class="dropdown-divider"></div>
                    </div>
                </li>
            </ul>
            <form class="form-inline my-2">
                <input class="form-control mr-sm-2" type="search" placeholder="Search">
            </form>
            <ul class="navbar-nav ml-5 mr-5">
                <li class="nav-item dropdown mx-1 btn btn-primary">
                    <a class="nav-link dorpdown-toggle text-white" href="#" data-toggle="dropdown">
                        <i class="fas fa-user"></i>&nbsp; Anonymous &nbsp;</a>
                    <div class="dropdown-menu">
                        <a class="dropdown-item" href="{% url 'home' %}">Login</a>
                        <a class="dropdown-item" href="{% url 'home' %}">Register</a>
                    </div>
                </li>
            </ul>
        </div>
    </nav>

    <div class="container">
        {% block content %}{% endblock %}
    </div>

{% block footer %}{% endblock %}

<!--Bootstrap core JavaScript-->
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

{% block extra-script %}{% endblock %}

</body>
</html>

templates/home.html
{% extends 'base.html' %}

{% load static %}

{% block title %}home.html{% endblock %}

{% block extra-style %}
<style type="text/css">

.home-window {
    background-image: url("{% static 'img/dragon.png' %}");
    background-repeat: no-repeat;
    background-position: center;
    background-size: 50%;
    height: 500px;
    border-top: 10px solid #ccc;
    border-bottom: 10px solid #ccc;
    color: yellow;
    padding: 20px 0 0 20px;
}
.title {
    color: #c80;
    font-weight: bold;
}
.powered {
    position: relative;
    top: 77%;
    color: #cc0;
    font-style: italic;
}

.footer-wrapper {
    background: #456;
    color: #eee;
    line-height: 50px;
}
.footer-wrapper a {
    color: #ff9;    /* footer-right text */
}
.footer-wrapper a:hover {
    color: #0ff;
}
footer ul li {
    text-align: center;
}

</style>
{% endblock extra-style %}

{% block content %}
    <div class="home-window">
        <h2 class="title">Django Web</h2>
        <h4 class="powered"><i class="fas fa-cog"></i> django & bootstrap </h4>
    </div>

    <hr style="margin: 10px 0;">

    <div class="row text-center">
        <div class="col-sm-6">
            <h3>Todo App</h3>
            <p>With Todo app, you can manage, prioritize, and complete the most important things
                you need to do every day. I can focus on the most important things
                and I can do my day more deliberately.
                You can also share lists with colleagues, friends, and family.</p>
        </div>
        <div class="col-sm-6">
            <h3>Blog App</h3>
            <p>This application makes it possible to log daily events or write your own interests
                such as hobbies, techniques, etc.
                A typical blog combines text, digital images, and links to other blogs, web pages,
                and other media related to its topic.</p>
        </div>
    </div>
{% endblock content %}

{% block footer %}
<footer class="fixed-bottom footer-wrapper">
    <div class="container">
        <div class="row">
            <div class="col-md-4">
                <p>Copyright &copy; 2020 DjangoWeb </p>
            </div>
            <div class="col-md-8">
                <ul class="list-inline float-right">
                    <li class="list-inline-item">
                        <a href="#" data-toggle="tooltip" data-placement="top" title="준비중입니다">Introduction</a>
                    </li>
                    <li class="list-inline-item">
                        <a href="#" data-toggle="tooltip" data-placement="top" title="준비중입니다">Help</a>
                    </li>
                    <li class="list-inline-item">
                        <a href="#" data-toggle="tooltip" data-placement="top" title="준비중입니다">Policy</a>
                    </li>
                    <li class="list-inline-item">
                        <a href="#" data-toggle="tooltip" data-placement="top" title="준비중입니다">Something</a>
                    </li>
                </ul>
            </div>
        </div>
    </div>
</footer>
{% endblock footer %}

{% block extra-script %}
<script>
$(function () {
    $('[data-toggle=tooltip]').tooltip();
});
</script>
{% endblock extra-script %}

templates/todo/todo_index.html
{% extends 'base.html' %}

{% block title %}Vue & Django Todo app{% endblock %}

{% block extra-style %}
<style>
    body {
        text-align: center;
        background-color: #ddd;
    }
    .inputBox {
        margin: auto;
        width: 70%;
        background: white;
        height: 50px;
        border-radius: 50px;
        line-height: 50px;
    }
    .inputBox .name {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 90px;
        padding-left: 20px;
        line-height: 20px;
    }
    .inputBox .item {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 400px;
        margin-left: 50px;
        padding-left: 20px;
        line-height: 20px;
    }
    .todoList {
        list-style: none;
        padding: 10px 0;
        text-align: left;
    }
    .todoList li {
        display: flex;
        height: 50px;
        line-height: 50px;
        margin: 0.5rem 0;
        padding: 0 0.9rem;
        background: white;
        border-radius: 5px;
    }
    .removeBtn {
        margin-left: auto;
        font-size: 20px;
    }
    .removeBtn:hover {
        color: red;
    }
</style>
{% endblock %}

{% block content %}
<div id="app">
    <h1>ToDo</h1>
    <strong>오늘의 할 일</strong>
    <br>
    <!--vue.js 에서 data 를 보내므로 form 태그 필요없음-->
    <div class="inputBox">
        <!--v-model=name 과 todo 로 입력받은 데이터를 vue 인스턴스의 data 의 name 과 todo 로 바인딩한다.-->
        <!--model 의 field 와 바인딩될 v-model 이 같아야 한다.-->
        <!--v-model.trim 을 사용하면 입력앞뒤에 공백을 제거하여 대입한다.-->
        <input class="name" type="text" placeholder="이름" v-model.trim="name">
        <input class="item" type="text" placeholder="할 일을 입력하세요~"
               v-model.trim="todo" v-on:keyup.enter="add_todo()">
        <!-- 버튼을 클릭하면 add_todo 메서드를 호출 -->
        <!--추가 버튼을 누르면 클릭 event 수신의 위해 v-on:click 을 사용-->
        <button v-on:click="add_todo()" class="btn btn-primary btn-sm">추가</button>
    </div>

    <ul class="todoList">
        <li v-for="(todo, index) in todoList">
            <span>[[ todo.name ]]:: [[ todo.todo ]]</span>
            <span class="removeBtn" v-on:click="remove_todo(todo, index)">x</span>
        </li>
    </ul>
</div>
{% endblock %}

{% block extra-script %}
<!-- 뷰 CDN 연결 및 Vue instance 생성하기 -->
<script src="https://unpkg.com/vue/dist/vue.min.js"></script>
<!--axios CDN 연결-->
<script src="https://unpkg.com/axios/dist/axios.min.js"></script>
<script>
    axios.defaults.xsrfCookieName = 'csrftoken';
    axios.defaults.xsrfHeaderName = 'X-CSRFToken';

    var vm = new Vue({
        delimiters: ['[[', ']]'],
        /*element option 으로 vue 에 붙어갈 최상의 element 사용 id 가 app 인 태그*/
        el: '#app',
        /*Vue 에 사용 될 변수로 input 태그에 입력받은 v-model 의 data 를 변수에 넣는다.*/
        /*각각 name 과 todo 변수값을 todoList 배열에 push 하게 된다.*/
        data: {
            name: '',
            todo: '',
            todoList: [],
        },
        /*Vue instance 생성시 created hook method 가 호출되고 django 에 axios.get 요청하고
        vue.js 에서는 created, mounted, updated lifecycle hook 제공 */
        created: function () {
            console.log('created(): ');
            /*vue.js 내 this 는 vue instance 를 말하므로 아래 this.fetch_all_todo 는 vue 객체내에
            * fetch_all_todo: function 을 말한다.*/
            this.fetch_all_todo();
        },
        methods: {
            /*axios.get 문법은 url 처리 성공시 callback 함수를 then() 에 넣고 실패시 catch() 에 넣는다.*/
            fetch_all_todo: function () {
                console.log('fetch_all_todo(): ');

                var vm = this;
                /*아래 this 는 axios.get 내의 callback 함수 내에 정의된 것은 windows 객체를 의미하므로
                 * this.todoLIst 는 정의되어 있지 않아 local variable 에 this 를 저장하여 사용하면 된다.*/
                axios.get('/api/todo/list/')
                    .then(function (res) {
                        console.log('GET RES', res);
                        /*this.todoList = res.data;*/
                        vm.todoList = res.data;  // server 로 부터 받은 res 의 data 객체를 vue instance todoList 대입
                    })
                    .catch(function (err) {
                        console.log('GET ERR', err);
                    })
            },
            add_todo: function () {
                console.log("add_todo(): ");
                /*사용자를 입력 안했을 때 무기명넣기 내용이 없으면 리턴*/
                if (this.todo == '') return;
                if (this.name == '') this.name = '익명';

                var vm = this;
                var postData = {name: this.name, todo: this.todo};
                axios.post('/api/todo/create/', postData, {xsrfCookieName: 'csrftoken', xsrfHeaderName: 'X-XSRFToken'})
                    .then(function (res) {
                        console.log('POST RES', res);
                        vm.todoList.push({id: res.data.id, name: res.data.name, todo: res.data.todo});
                    })
                    .catch(function (err) {
                        console.log('POST ERR', err);
                    })
                /*사용자가 입력한 내용 지우기*/
                this.name = this.todo = '';
            },
            remove_todo: function (todo, index) {
                console.log("remove_todo(): ", index);
                if (confirm('정말로 삭제하시겠습니까?') == false) return;
                /*삭제시 index 에 해당하는 것을 한개 삭제*/
                var vm = this;
                axios.delete('/api/todo/' + todo.id + '/delete/')
                    .then(function (res) {
                        console.log('Delete Res', res);
                        vm.todoList.splice(index, 1);
                    })
                    .catch(function (err) {
                        console.log('Delete Err', err);
                    })
            },
        },
    })
</script>
{% endblock %}